/ EDUC 8 PRINTER CODES PROGRAM
/ EA APRIL 75 PG 69
/ PRINTER MODULE TO OUTPUT DEVICE 0

/ RUN FROM "START"
/ RECOMPILE FOR RE-USE TO RESET PRINT MSG BUFFER

/ *** NOTE: THIS PROGRAM USES THE PAGE ZERO OPTION ENABLED ***

	_ISZEROPAGEON

BUFFADR,	MSGBFR
PTR,
COUNT,
AND7,	#D7
OCT60,	#0060
PBUF,	PBUFFER
NEXTCODE,	CODELOOP
	NOP

START,	JMS I PBUF
	JMP I DOCODEI
DOCODEI,	DOCODE

	_PAGEBREAK

PBUFFER,	_SUBRETURN
	CLA
	TAD BUFFADR	/ start of message buffer to pointer
	DCA PTR

FETCH,	TAD I PTR	/ fetch char
	IAC	/ if 255, then + 1 = 0
	SZA	/ 0 = terminate code?
	JMP .+2	/ no, keep going
	JMP I PBUFFER	/ yes, print
	CLA
	TAD I PTR	/ fetch char
	LDB 0	/
	SDF 0	/ print sequence
	JMP .-1	/
	ISZ PTR	/ increment pointer - assumes wont = 0
	JMP FETCH	/ continue

	_PAGEBREAK	

/ *** PRINT THE 64 CODE CLINES

DOCODE,	DCA COUNT	/ count = 0
CODELOOP,	TAD BUFFADR	/ start of message buffer to pointer
	DCA PTR

/ INPUT CHARACTER
	
	TAD COUNT	/ current code line
	DCA I PTR	/ to buffer
	ISZ PTR	/ assumes no wrap around

/ ADD 6 SPACES TO BUFFER

	JMS I DOSPAC
	JMP DOOCT	

DOSPAC,	PRNSPACES

/ INPUT 1ST OCTAL VALUE FOR CURRENT COUNT
DOOCT,	TAD COUNT
	RAR	/ shift into bits [210]
	RAR
	RAR
	AND AND7	/ mask lower 3 bits
	TAD OCT60
	DCA I PTR
	ISZ PTR	/ assumes no wrap around

/ INPUT 2ND OCTAL VALUE FOR CURRENT COUNT

	TAD COUNT
	AND AND7	/ mask lower 3 bits
	TAD OCT60
	DCA I PTR
	ISZ PTR	/ assumes no wrap around

/ SPACES TO END OF LINE

	TAD SPCTOEND
	DCA I PTR
	ISZ PTR	/ assumes no wrap around
	JMP DOFINBF

SPCTOEND,	#B10100000	/ BIT 7 = 1 + space value -> rest of line = spaces
BUFFEND,	#D255

/ ADD 255 TO END OF BUFFER TO SIGNAL END OF BUFFER

DOFINBF,	TAD BUFFEND
	DCA I PTR

/ PRINT THE BUFFER

	JMS I PBUF

/ NEXT COUNT

	NOP
	TAD COUNT
	IAC
	DCA COUNT

/ IF COUNT = 64 THEN END

	TAD COUNT
	AND END64
	SZA
	JMP NEXTCODE5

/ ALL DONE ********************************************

	HLT

/ *****************************************************

NEXTCODE5,	CLA
	JMP I CODLOOP

END64,	#D63
CODLOOP,	CODELOOP

	_PAGEBREAK

/ INPUT 6 SPACES - COUNT IN AC

PRNSPACES,	_SUBRETURN
	TAD SPACES6
	DCA SPCCNT
SPCLOOP,	TAD SPACECHR	/ space to buffer
	DCA I PTR
	ISZ PTR	/ assumes no wrap around
	ISZ SPCCNT
	JMP SPCLOOP
	JMP I PRNSPACES
SPACES6,	#D250
SPCCNT,
SPACECHR,	#P" " 	/ space character value


/ *** PRINT MESSAGE HEADER FROM ARTICLE ***

MSGBFR,	_PSTRING "PHILIPS 60SR~ "
	_PSTRING "CHARACTER CODES~ "
	_PSTRING "(77 FORMAT OCTAL)~ "
	_PSTRING "~ "		/ blank line
	_PSTRING "CHAR   CODE~ "
	#D255		/ end of buffer data

	_END
