/ EDUC 8 AUDIO TAPE DATA WRITE
/ EA JULY 75 PG 69
/ CREATE AN AUDIO DATA TAPE OF GREEN SLEEVES MUSIC
/ TAPE MODULE TO INPUT/OUTPUT DEVICE 0
/ ENTER BEGIN ADDRESS AT: ADDRESS
/ ENTER BYTE COUNT AT: COUNT
/ ASSUMES TAPE MODULE IS READY WHEN RUNNING PROGRAM

/ START TAPE "RECORD"
/ THEN RUN FROM "START"
/ RECOMPILE BEFORE RE-USE


/ WHEN RE-LOADED FROM TAPE
/ THE MUSIC PROGRAM STARTS AT 111 EDUC OCTAL
/ SET THE MELODY MODULE TO DEVICE 1 BEFORE RUNNING THE PROGRAM

	_ISZEROPAGEOFF

/ subroutine: write data and wait for ready
ADDRESS,	#E100	/ start address
COUNT,	#D100	/ byte count
TAPESUBA,	TAPESUB

START,	CLA	/ 0 - count
	TAD COUNT
	CMA.IAC
	DCA COUNT

	TAD ADDRESS	/ send start address
	JMS I TAPESUBA

LOOP,	TAD I ADDRESS	/ send memory data
	JMS I TAPESUBA

	TAD ADDRESS
	IAC
	DCA ADDRESS	/ next memory address

	ISZ COUNT	/ all done?
	JMP LOOP	/ no
	HLT	/ yes

TAPESUB,	_SUBRETURN
	LDB 0
RDYWAIT,	SDF 0
	JMP RDYWAIT
	JMP I TAPESUB


	_SETPC #0040

PLAY,	_SUBRETURN
	LDB 1
WAIT,	SDF 1
	JMP WAIT
	JMP I PLAY

INDY,	#0
BUFS,	#0070
MASK,	#0300

STARTMUS,	CLA
	TAD BUFS
	DCA INDY
GO,	TAD I INDY
	JMS PLAY
	TAD I INDY
	AND MASK
	JMS PLAY

	ISZ I INDA
	JMP I GOAD
	HLT
	JMP I STTA
STTA,	START
GOAD,	GO
INDA,	INDY
	NOP

	#N21A	/ a-

	#N31C	/ las
	#N21D	/ my
	#N21E	/ love
	#N11F	/ you
	#N21E	/

	#N31D	/ do
	#N21B	/ me
	#N21G	/ wrong
	#N11A	/ 
	#N21B	/ to

	#N31C	/ cast
	#N21A	/ me
	#N21A	/ off
	#N11G	/ 
	#N21A	/ dis

	#N31B	/ court-
	#N21G#	/ eous-
	#N31E	/ ly,
	#N21A	/ for

	#N31C	/ I
	#N21D	/ have
	#N21E	/ loved
	#N11F	/
	#N21E	/

	#N31D	/ you
	#N21B	/ so
	#N21G	/ long
	#N11A	/
	#N21B	/ de-

	#N21C	/ ligh-
	#N11B	/
	#N21A	/ ting
	#N21G#	/ in
	#N11F#	/ 
	#N21G#	/ your

	#N31A	/ com-
	#N21A	/ pa-
	#N31A	/ ny.
	#N20X	/

	#N32G	/ Green
	#N22G	/ Sleeves
	#N12F#	/ was
	#N21E	/

	#N31D	/ all
	#N21B	/ my
	#N21G	/ joy
	#N11A	/
	#N21B	/

	#N31C	/ Green
	#N21A	/
	#N21A	/ Sleeves 
	#N11G	/
	#N21A	/ was 

	#N31B	/ my
	#N21G	/ de-
	#N31E	/ light,
	#N20X	/

	#N32G	/ Green
	#N22G	/ Sleeves
	#N12F#	/ was
	#N21E	/ my

	#N31D	/ heart
	#N21B	/ of
	#N21G	/ gold
	#N11A	/
	#N21B	/ and

	#N21C	/ who
	#N11B	/ but
	#N21A	/ my
	#N21G#	/ la-
	#N11F#	/
	#N21G#	/ dy

	#N31A	/ green
	#N31A	/ sleeves
