/ EDUC 8 WIF PRINTER CODES PROGRAM
/ EA APRIL 75 PG 69
/ PRINTER MODULE TO OUTPUT DEVICE 0
/ RUN FROM "START"

	_RAM

PTR
CODE
CNT
BCD
TEMP
PMODE

	_ENDRAM

_CONST PRNMODE #D1	/ IF = #D0 THEN PRINT OCTAL CODE
		/ IF = #D1 THEN PRINT DECIMAL CODE

	_ISWIMODEON

START,	MOVVA PRNMODE
	MOVR A PMODE
	CLRR PTR R	/ initialise pointer
	ROMPTR H 0	/ PC jump tables located in ROM page 0

CON1,	GOSUB MSGNAM	/ fetch char
	SKIPIFA >= 1	/ terminate code? (@ = 0)
	GOTO OCTDEC	/ yes, stop printing

	GOSUB DOPRINT	/ print the character
	INCR PTR R	/ get code value
	GOTO CON1	/ continue
/---------------------------------
OCTDEC,	CLRR PTR R	/ initialise pointer
CON2,	SKIPBC PMODE 0
	GOTO PRNDEC

	GOSUB MSGOCT	/ fetch octal msg char
	GOTO TST02

PRNDEC,	GOSUB MSGDEC	/ fetch decimal msg char

TST02,	SKIPIFA >= 1	/ terminate code? (@ = 0)
	GOTO PRNHDR	/ yes, stop printing

	GOSUB DOPRINT	/ print the character
	INCR PTR R	/ get code value
	GOTO CON2	/ continue
/---------------------------------
PRNHDR,	CLRR PTR R	/ initialise pointer
	ROMPTR H 0	/ PC jump tables located in ROM page 0

CON3,	GOSUB MSGHDR	/ fetch char
	SKIPIFA >= 1	/ terminate code? (@ = 0)
	GOTO CODES	/ yes, stop printing

	GOSUB DOPRINT	/ print the character
	INCR PTR R	/ get code value
	GOTO CON3	/ continue
/ ------------------------------------------

CODES,	CLRR CODE R	/ clear code number
CODESLP,	MOVR CODE A	/ get code value
	GOSUB DOPRINT	/ print the code
	MOVVA 6	/ 6 SPACES
	GOSUB SPACES	/ print 6 spaces
	GOSUB CODENUM	/ print 2 digit code
	MOVVA #D160	/ 128 + space char code
	GOSUB DOPRINT	/ spaces to end of line
	INCR CODE R	/ next code
	SKIPBS CODE 6	/ if > 63 then stop
	GOTO CODESLP

STOP,	HALT	/ end of buffer - stop
	GOTO START

/ ------------------------------------------
SPACES,	MOVR A CNT
S6LOOP,	MOVVA #D32	/ space character	
	GOSUB DOPRINT	/ print the character
	DECRSZ CNT R
	GOTO S6LOOP
	RETURN

/ ------------------------------------------
CODENUM,	SKIPBC PMODE 0
	GOTO TOBCD2

CODEOCT,	ROTR CODE A	/ 1st octal digit
	MOVR A CNT
	ROTR CNT R
	ROTR CNT A
	ANDVA 7
	GOSUB DOPRINT30
	MOVR CODE A	/ 2nd octal digit
	ANDVA 7
	GOSUB DOPRINT30
	RETURN

TOBCD2,	MOVR CODE A
	MOVR A TEMP
	CLRR BCD R
LOOP10,	MOVVA #D10	/ count how many 10's are in CODE
	INCR BCD R
	SUBR A TEMP T
	STSKIP C CLR
	GOTO LOOP10
	DECR BCD A
	GOSUB DOPRINT30	/ print 10's
	MOVVA #D10	/ last decrement went neagtive so
	ADDR TEMP A T	/ add 10 for units value
	GOSUB DOPRINT30	/ print units
	RETURN

/ ------------------------------------------
DOPRINT30,	ADDVA #$30	/ + hex $30
DOPRINT,	WTORST DEV0 A	/ print the character
PRNWAIT,	SKIPOF DEV0	/ wait until printer ready
	GOTO PRNWAIT
	RETURN

/ *** PRINT MESSAGE HEADER FROM ARTICLE ***

MSGNAM,	ADDR PTR P T
	_PSTRING "PHILIPS 60SR~ "
	_PSTRING "CHARACTER CODES~ "
	_PSTRING "@"

MSGOCT,	ADDR PTR P T
	_PSTRING "(77 FORMAT OCTAL)~ "
	_PSTRING "@"
MSGDEC,	ADDR PTR P T
	_PSTRING "(FORMAT DECIMAL)~ "
	_PSTRING "@"

MSGHDR,	ADDR PTR P T
	_PSTRING "~ "		/ blank line
	_PSTRING "CHAR   CODE~ "	/ @ = end of buffer
	_PSTRING "@"

	_END
