/EDUC-8 Minimum Octal Read Program by Steven S. Pietrobon 4 Jan 2009
/
/This program allows you to display programs using the EDUC-8 Keypad
/and Octal Display. Set the Octal Display to 737. The Keypad is connected to 
/ID0 and the Octal Display to OD0.
/
/After entering this program, enter the address index (IDX) of the program to 
/be written at address 010. Then enter the start address of this program 000
/and run the program. The IDX will be displayed on AC and the contents at 
/address IDX will be shown on the octal display. Press any key on the keypad to
/increment IDX and display the next contents at address IDX.
/
/If you get out of step, halt the program, re-enter the new IDX, and then 
/restart the program. The program uses a total of 10 words in one page.

	_ISZEROPAGEOFF

START,	CLA
	TAD I IDX
	LDS 0	/ write(P[IDX])
	TAD IDX	/ AC := IDX
TESTCHAR,	SKF 0	/ if CHARFLAG = 0
	JMP TESTCHAR	/ then TESTCHAR else
	RKF 0	/ clear FLAG
	ISZ IDX	/ IDX := IDX+1
	JMP START

IDX,		/ Program Index
