/ CREATE A PAPER TAPE OF CURRENT MEMORY
/ PAPER PUNCH MODULE TO OUTPUT DEVICE 0
/ ENTER BEGIN ADDRESS AT: ABEGIN
/ ENTER BYTE COUNT AT: ACOUNT
/ ASSUMES PAPER PUNCH IS READY WHEN RUNNING PROGRAM
/ RUN FROM "START"

PAPERSTART,	#D128	/ paper tape start byte
ACOUNTA,	ACOUNT
ABEGINA,	ABEGIN

/ subroutine: punch data and wait for punch to be ready
PUNCHSUB,	_SUBRETURN
	LDB 0
RDYWAIT,	SDF 0
	JMP RDYWAIT
	JMP I PUNCHSUB

START,	CLA.IAC	/ 0 - count
	TAD I ACOUNTA
	CMA.IAC
	DCA I ACOUNTA

	TAD PAPERSTART	/ punch start byte
	JMS PUNCHSUB

	TAD I ABEGINA	/ punch start address
	JMS PUNCHSUB


LOOP,	TAD I ABEGIN	/ send memory data
	JMS I PUNCHSUBA

	TAD ABEGIN
	IAC
	DCA ABEGIN	/ next memory address

	ISZ ACOUNT	/ all done?
	JMP LOOP	/ no
	HLT	/ yes

PUNCHSUBA,	PUNCHSUB
ABEGIN,	#0	/ start address
ACOUNT,	#D29	/ byte count
