/ EDUC-8 WIF KIT DISPLAY
/ RUN FROM START

	_RAM

ROLREG		/ Roll register
DELREGH		/ Delay counters
DELREGL

	_ENDRAM

	_ISWIMODEON

START,	CLRR DELREGL R
	CLRR DELREGH R
	GOSUB IDELH
	MOVVA #D1	/ initialise bit

LLOOP,	GOSUB DELAY	/ wait
	ROTL A A	/ next bit left
	SKIPBS A 7	/ bit 7 set?
	GOTO LLOOP

RLOOP,	GOSUB DELAY	/ wait
	ROTR A A	/ next bit right
	SKIPBS A 0	/ bit 7 clear?
	GOTO RLOOP
	GOTO LLOOP	/ start again
	
DELAY,	DECRSZ DELREGL R	/ wait delay
	GOTO DELAY	/ longer  = DELREGH higher value
	DECRSZ DELREGH R	/ shorter = DELREGH lower value
	GOTO DELAY	/

IDELH,	INCR DELREGH R	/ reset DELREGH
	INCR DELREGH R	/ leaves AC register as is
	INCR DELREGH R
	RETURN
